class Opcode {
  public static final char NO_OP                    =   0;
  public static final char HEADER                   =   1;
  public static final char DATA                     =   2;
  public static final char ACKNOWLEDGEMENT          =   6;
  public static final char NEGATIVE_ACKNOWLEDGEMENT =   7;
  public static final char REQUEST_NEW_ROBOT_IDS    =   8;
  public static final char REQUEST_INFO             =   9;
  public static final char REQUEST_SENSOR_LAYOUT    =  10;
  public static final char REQUEST_SENSOR_DATA      =  11;
  public static final char REQUEST_SONAR_DATA       =  12;
  public static final char SET_ERROR_CORRECTION     =  13;
  public static final char SET_SENSE                =  14;
  public static final char SET_SCAN_RANGE           =  15;
  public static final char SET_AUTO_SCAN            =  16;
  public static final char SCAN                     =  17;
  public static final char MOVE                     =  18;
  public static final char STOP                     =  19;

  public static String stringValue(char opcode){
    String value = "UNKNOWN";
    switch(opcode){
      case NO_OP:
        value = "NO_OP";
        break;
      case HEADER:
        value = "HEADER";
        break;
      case DATA:
        value = "DATA";
        break;
      case ACKNOWLEDGEMENT:
        value = "ACKNOWLEDGEMENT";
        break;
      case NEGATIVE_ACKNOWLEDGEMENT:
        value = "NEGATIVE_ACKNOWLEDGEMENT";
        break;
      case REQUEST_NEW_ROBOT_IDS:
        value = "REQUEST_NEW_ROBOT_IDS";
        break;
      case REQUEST_INFO:
        value = "REQUEST_INFO";
        break;
      case REQUEST_SENSOR_LAYOUT:
        value = "REQUEST_SENSOR_LAYOUT";
        break;
      case REQUEST_SENSOR_DATA:
        value = "REQUEST_SENSOR_DATA";
        break;
      case REQUEST_SONAR_DATA:
        value = "REQUEST_SONAR_DATA";
        break;
      case SET_ERROR_CORRECTION:
        value = "SET_ERROR_CORRECTION";
        break;
      case SET_SENSE:
        value = "SET_SENSE";
        break;
      case SET_SCAN_RANGE:
        value = "SET_SCAN_RANGE";
        break;
      case SET_AUTO_SCAN:
        value = "SET_AUTO_SCAN";
        break;
      case SCAN:
        value = "SCAN";
        break;
      case MOVE:
        value = "MOVE";
        break;
      case STOP:
        value = "STOP";
        break;
    }
    return value;
  }  
}

class Movement {
  public static final char NOWHERE                  =   0;
  public static final char MOVE_FORWARD             =   1;
  public static final char MOVE_BACKWARD            =   2;
  public static final char TURN_LEFT                =   3;
  public static final char TURN_RIGHT               =   4;
}

class RobotLocation {
  public static final char LOGIC                    =   0;
  public static final char FRONT                    =   1;
  public static final char BACK                     =   2;
  public static final char LEFT                     =   3;
  public static final char RIGHT                    =   4;
  public static final char FRONT_LEFT               =   5;
  public static final char BACK_LEFT                =   6;
  public static final char FRONT_RIGHT              =   7;
  public static final char BACK_RIGHT               =   8;
  public static final char LEFT_FRONT               =   9;
  public static final char LEFT_BACK                =  10;
  public static final char RIGHT_FRONT              =  11;
  public static final char RIGHT_BACK               =  12;
  public static final char TOP_FRONT                =  13;
  public static final char TOP_BACK                 =  14;
  public static final char TOP_LEFT                 =  15;
  public static final char TOP_RIGHT                =  16;
  public static final char TOP_MIDDLE               =  17;

  public static String stringValue(char location){
    String value = "UNKNOWN";
    switch(location){
    case FRONT:
      value = "FRONT";
      break;
    case BACK:
      value = "BACK";
      break;
    case LEFT:
      value = "LEFT";
      break;
    case RIGHT:
      value = "RIGHT";
      break;
    case FRONT_LEFT:
      value = "FRONT_LEFT";
      break;
    case BACK_LEFT:
      value = "BACK_LEFT";
      break;
    case FRONT_RIGHT:
      value = "FRONT_RIGHT";
      break;
    case BACK_RIGHT:
      value = "BACK_RIGHT";
      break;
    case LEFT_FRONT:
      value = "LEFT_FRONT";
      break;
    case LEFT_BACK:
      value = "LEFT_BACK";
      break;
    case RIGHT_FRONT:
      value = "RIGHT_FRONT";
      break;
    case RIGHT_BACK:
      value = "RIGHT_BACK";
      break;
    case TOP_FRONT:
      value = "TOP_FRONT";
      break;
    case TOP_BACK:
      value = "TOP_BACK";
      break;
    case TOP_LEFT:
      value = "TOP_LEFT";
      break;
    case TOP_RIGHT:
      value = "TOP_RIGHT";
      break;
    case TOP_MIDDLE:
      value = "TOP_MIDDLE";
      break;
    }
    return value;
  }
}

