class Packet {

  public char preamble;
  public char source_id;
  public char destination_id;
  public char packet_id;
  public char opcode;
  public char length;
  public char[] data;
  public char crc;

  public Packet(){
    this.preamble=0;
    this.source_id=0;
    this.destination_id=0;
    this.packet_id=0;
    this.opcode=0;
    this.length=0;
    this.data=null;
    this.crc=0;
  }

  public Packet(char preamble, char source_id, char destination_id, char packet_id,
                char opcode, char length, char[] data, char crc) {
    this.preamble=preamble;
    this.source_id=source_id;
    this.destination_id=destination_id;
    this.packet_id=packet_id;
    this.opcode=opcode;
    this.length=length;
    this.data=data;
    this.crc=crc;
  }

  public String toString() {
    String value = "{PRE SRCID DSTID PKTID ";
    value+=Opcode.stringValue(opcode);
    value+=" LEN [ ";
    for(int i=0; i<length; i++)
      value+=(int)data[i]+" ";
    value+="] CRC";
    return value;
  }
}
