import java.util.Vector;

public class PhysicalRobot extends Robot
{
  public PhysicalRobot(char id) {
    super(id);
  }

  public char[] getSensorData() {
    char[] data = new char[sensors.size()+info.getSonarDataSize()];
    Sensor sensor;
    for(int i=0, j=0; i<sensors.size() && j<data.length; i++) {
      sensor = (Sensor)sensors.elementAt(i);
      if(sensor.type == SensorType.SONAR_SENSOR) {
        for(int k=0; k<((SonarSensor)sensor).value.length && j<data.length; k++, j++)
          data[j] = ((SonarSensor)sensor).value[k];
      } else {
        data[j] = ((SimpleSensor)sensor).value;
        j++;
      }
    }
    return data;
  }

  public void setSensorData(char[] data) {
    for(int i=0, j=0; i<sensors.size() && j<data.length; i++) {
      if(((Sensor)sensors.elementAt(i)).type == SensorType.SONAR_SENSOR){
        j+=((SonarSensor)sensors.elementAt(i)).value.length;
        continue;
      } else {
        ((SimpleSensor)sensors.elementAt(i)).value = data[j];
        j++;
      }
    }
  }

  public void setSonarData(char[] data) {
    for(int i=0, j=0; i<sensors.size() && j<data.length; i++) {
      if(((Sensor)sensors.elementAt(i)).type == SensorType.SONAR_SENSOR) {
        SonarSensor ss = (SonarSensor)sensors.elementAt(i);
        for(int k=0; k<ss.value.length && j<data.length; k++, j++)
          ss.value[k] = data[j];
      } else {
        j++;
        continue;
      }
    }
  }
}
