import javax.swing.*;
import java.util.Vector;
import java.awt.Component;
import java.awt.BorderLayout;
import javax.swing.border.TitledBorder;

public class RobotInfoViewer extends JPanel {
  JList robot_list;

  public RobotInfoViewer() {
    super();
    init();
  }

  private void init() {
    robot_list = new JList();
    robot_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    robot_list.setCellRenderer(new RobotListCellRenderer());
    JScrollPane sp = new JScrollPane(robot_list);
    this.add(sp, BorderLayout.CENTER);
    this.setBorder(new TitledBorder("Robot List"));
  }

  public void refresh(Vector robots) {
    Object selected = robot_list.getSelectedValue();
    robot_list.setListData(robots);
    robot_list.setSelectedValue(selected, true);
  }

  public Robot getSelectedRobot() {
    return (Robot)robot_list.getSelectedValue();
  }
}

class RobotListCellRenderer extends JLabel implements ListCellRenderer {
  public Component getListCellRendererComponent(
    JList list,
    Object value,            // value to display
    int index,               // cell index
    boolean isSelected,      // is the cell selected
    boolean cellHasFocus)    // the list and the cell have the focus
  {
    String text = value.toString();

	  setFont(list.getFont());
    setOpaque(true);

    if(((Robot)value).isReady())
      text = "<html><b>"+text+"</b></html>";
    else
      text = "<html><font color=gray><i>"+text+"</i></font></html>";

    setText(text);
 
    if(((Robot)value).isReady() && !((Robot)value).isOwned())
      setEnabled(true);
    else
      setEnabled(false);

    if(isEnabled()) {
      if (isSelected) {
        setBackground(list.getSelectionBackground());
        setForeground(list.getSelectionForeground());
      } else {
        setBackground(list.getBackground());
        setForeground(list.getForeground());
      }
    }

    return this;
  }
}
