import java.util.Vector;

public interface RobotServer extends Runnable {
  public static final char MAX_CONNECTIONS = 250;

  public void setGUI(ServerGUI gui);
  public Vector getRobots(boolean all_robots);
  public Robot getRobot(char robot_id);
  public void pollForRobots();
  public boolean connectRobot(Robot robot);
  public void disconnectRobot(Robot robot);
  public void updateRobotInfo(Robot robot);
  public void updateRobotSensorData(Robot robot);
  public void updateRobotSensorLayout(Robot robot);
  public void setSense(char client_id, char robot_id, boolean sense);
  public void setAutoScan(char client_id, char robot_id, boolean auto_scan);
  public void scanOnce(char client_id, char robot_id);
  public void moveRobot(char client_id, char robot_id, char direction, char distance);
  public void stopRobot(char client_id, char robot_id);
  public void startLocalClient(Robot robot);
}
