import java.util.Arrays;

class SensorType {
  public static final char TIMEOUT_SENSOR           =   0;
  public static final char BUMP_SENSOR              =   1;
  public static final char IR_SENSOR                =   2;
  public static final char LIGHT_SENSOR             =   3;
  public static final char SONAR_SENSOR             =   4;
  public static final char REFLECTANCE_SENSOR       =   5;
  public static final char BREAK_BEAM_SENSOR        =   6;

  public static String stringValue(char type){
    String value = "UNKNOWN";
    switch(type){
    case TIMEOUT_SENSOR:
      value = "TIMEOUT SENSOR";
      break;
    case BUMP_SENSOR:
      value = "BUMP SENSOR";
      break;
    case IR_SENSOR:
      value = "IR SENSOR";
      break;
    case LIGHT_SENSOR:
      value = "LIGHT SENSOR";
      break;
    case SONAR_SENSOR:
      value = "SONAR SENSOR";
      break;
    case REFLECTANCE_SENSOR:
      value = "REFLECTANCE SENSOR";
      break;
    case BREAK_BEAM_SENSOR:
      value = "BREAK BEAM SENSOR";
      break;
    }
    return value;
  }
}

abstract class Sensor {
  public char type;
  public char location;

  public Sensor(char type, char location){
    this.type = type;
    this.location = location;
  }
}

class SimpleSensor extends Sensor {
  public char value;

  public SimpleSensor(char type, char location) {
    super(type,location);
    value = 0;
  }
  public SimpleSensor(char type, char location, char value) {
    super(type,location);
    this.value = value;
  }
}

class SonarSensor extends Sensor {
  public char value[];

  public SonarSensor(char location, char size) {
    super(SensorType.SONAR_SENSOR,location);
    value = new char[size];
    Arrays.fill(value,'\0');
  }
}
