public class Server {
  public static void printUsage() {
    String usage="";
    usage += "Usage: java [options] Server\n";
    usage += "where options include:\n";
    usage += "  -simulate  Simulate robot responses\n";
    usage += "  -nogui     Do not display a GUI\n";
  }

  public static void main(String args[]) {
    boolean create_gui = true;

    //check command line arguments 
    RobotServer server = null;
    ServerGUI gui = null;

    for(int i=0; i<args.length; i++) {
      if(args[i].equals("-simulate"))
        server = new SimulatedRobotServer();
      else if(args[i].equals("-nogui"))
        create_gui = false;
      else {
        printUsage();
        System.exit(0);
      }
    }

    if(create_gui)
      gui = new ServerGUI();

    if(server==null)
      server = new PhysicalRobotServer();

    if(gui!=null){
      gui.setServer(server);
      server.setGUI(gui);
    }

    new Thread(server).start();
  }
}

