import java.io.*;

class test extends Thread {
  public static final char ROBOT_BUFFER_SIZE = 32;
  public static final long ROBOT_BUFFER_CLEAR_TIME = 10;
  public static final char SERVER_ID = 0;

  public static long DELAY = 0;
  public static boolean DEBUG = false;

  private Serial serial;

  public test(){
  }

  public void run(){
    Packet packet = null, response = null;
    boolean is_valid = false;
    String line;
    int choice, repetitions;
    long start_time, end_time;
    serial = new Serial();
    System.out.println("Testing ...");
    System.out.println();
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

    try {
 	System.out.print("Print debug messages? (y/n): ");
	line = in.readLine();
	if(line.equalsIgnoreCase("y") || line.equalsIgnoreCase("yes"))
	    DEBUG = true;
	else
	    DEBUG = false;

	System.out.print("Enter delay in ms (default 0): ");
	line = in.readLine();
	if(line.equals(""))
	  DELAY = 0;
	else
	  DELAY = Long.parseLong(line);
	System.out.println();
    } catch (Exception e) {
	DELAY = 0;
	DEBUG = false;
    }

    serial.setDebug(DEBUG);
    serial.setDelay(DELAY);

    while(true){
      try {
	repetitions = 1;
	System.out.println("Choose command:");
	System.out.println("1. Request robot ids");
	System.out.println("2. Request sensor data");
	System.out.println("3. Continuous Request of sensor data");
	System.out.println("4. Request sensor layout");
	System.out.print(">");
	line = in.readLine();
	choice = Integer.parseInt(line);
	if(choice>0 && choice<5){
	  switch(choice){
	  case 1:
	    System.out.println("Requesting New Robot IDs ...");
	    packet=new Packet(Opcode.HEADER, SERVER_ID, (char)1, (char)0, Opcode.REQUEST_NEW_ROBOT_IDS, (char)0, null, (char)0);
	    break;
	  case 2:
	    System.out.println("Requesting Sensor Data ...");
	    packet=new Packet(Opcode.HEADER, SERVER_ID, (char)1, (char)0, Opcode.REQUEST_SENSOR_DATA, (char)0, null, (char)0);
	    break;
	  case 3:
	    System.out.print("How many times?: ");
	    line = in.readLine();
	    repetitions = Integer.parseInt(line);
	    System.out.println("Requesting Sensor Data ...");
	    packet=new Packet(Opcode.HEADER, SERVER_ID, (char)1, (char)0, Opcode.REQUEST_SENSOR_DATA, (char)0, null, (char)0);
	    break;
	  case 4:
	    System.out.println("Requesting Sensor Layout");
	    packet=new Packet(Opcode.HEADER, SERVER_ID, (char)1, (char)0, Opcode.REQUEST_SENSOR_LAYOUT, (char)0, null, (char)0);
	  }
	} else
	  continue;
	start_time = System.currentTimeMillis();
	for(int i=0; i<repetitions; i++){
	  //send packet
	  serial.sendPacket(packet);

	  response = new Packet();
	  is_valid = serial.receivePacket(response);
	  if(!is_valid){
	    System.out.println("Failed!");
	    i--;
	  }
	}
	end_time = System.currentTimeMillis();

	if(!is_valid)
	  continue;

	if(DEBUG){
	  if(choice==4){
	    String type, location;
	    System.out.println("Sensor Type:            Sensor Location:");
	    for(int i=0; i+1<response.length; i+=2){
	      type = SensorType.stringValue(response.data[i]);
              location = RobotLocation.stringValue(response.data[i+1]);
	      String output = new String();
	      output += type;
	      for(int j=type.length(); j<24; j++)
		output+=' ';
	      output += location;
	      System.out.println(output);
	    }
	  }
	}
	float total_time = ((float)(end_time-start_time))/1000f;
	System.out.println("Total time: " + total_time);
	float avg_time = total_time/(float)repetitions;
	System.out.println("Average time: " + avg_time);
	System.out.println("Framerate (packets/second): " + ((float)repetitions)/total_time);
      } catch (IOException ioe) {
	System.out.println(ioe.getMessage());
	System.exit(1);
      } catch (NumberFormatException nfe) {
      }
    }
  }

  public static void main(String args[]){
    test t = new test();
    t.start();
  }
}
